(theory FiniteSetWithCard

 :written_by "Philipp Ruemmer, Cesare Tinelli" 
 :date "10/07/2009"

 :note "Formalization developed in cooperation with  
        Daniel Kroening, Georg Weissenbacher, and Ofer Strichman"

 :sorts ((Set 1) (Int 0))

 :funs ((par (X) (emptySet (Set X)))
        (par (X) (insert X (Set X) (Set X) :right_associative))
        (par (X) (in X (Set X) Bool))
        (par (X) (subset (Set X) (Set X) Bool :chainable))
        (par (X) (union (Set X) (Set X) (Set X) :left_associative))
        (par (X) (inter (Set X) (Set X) (Set X) :left_associative))
        (par (X) (setminus (Set X) (Set X) (Set X) :left_associative))
	)

 :funs ((par (X) (card (Set X) Int))
        )

 :funs ((NUMERAL Int) 
        (- Int Int)     ; unary minus
        (- Int Int Int :left_associative) ; binary minus
        (+ Int Int Int :left_associative) 
        (* Int Int Int :left_associative)
        (<= Int Int Bool :chainable)
        (< Int Int Bool :chainable)
        (>= Int IntBool :chainable)
        (> Int Int Bool :chainable)
        )

 :definition 
 "Let Q be a set of sort symbols including Set, Int, and Bool, and let
  S be the set of all (ground) sort terms over Q.  For any s in S and
  any function symbol f, let [[s]] and [[f]] respectively denote the
  interpretation of s and f in some given structure.

  For any S like the above, FiniteSetsWithCard(S) is the theory consisting
  of all structures satisfying the following restrictions for all s in S:

  - [[Int]] is the set of the set Z of integer numbers.

  - [[f]] is as expected if f is in { -, +, *, <=, <, >, >= }.

  - [[n]] is as expected if n is a numeral.

  - [[(Set s)]] is the set of all finite subsets of [[s]] 

  - [[f]] is as expected if f is in { emptySet, insert, in, subset,
    union, inter, setminus, card }.
 "
 )

